    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * -----------------------------
    028     * MeanAndStandardDeviation.java
    029     * -----------------------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes:
    036     * --------
    037     * 05-Feb-2002 : Version 1 (DG);
    038     * 05-Feb-2005 : Added equals() method and implemented Serializable (DG);
    039     * 02-Oct-2007 : Added getMeanValue() and getStandardDeviationValue() methods
    040     *               for convenience, and toString() method for debugging (DG);
    041     *
    042     */
    043
    044    package org.jfree.data.statistics;
    045
    046    import java.io.Serializable;
    047
    048    import org.jfree.util.ObjectUtilities;
    049
    050    /**
    051     * A simple data structure that holds a mean value and a standard deviation
    052     * value.  This is used in the
    053     * {@link org.jfree.data.statistics.DefaultStatisticalCategoryDataset} class.
    054     */
    055    public class MeanAndStandardDeviation implements Serializable {
    056
    057        /** For serialization. */
    058        private static final long serialVersionUID = 7413468697315721515L;
    059
    060        /** The mean. */
    061        private Number mean;
    062
    063        /** The standard deviation. */
    064        private Number standardDeviation;
    065
    066        /**
    067         * Creates a new mean and standard deviation record.
    068         *
    069         * @param mean  the mean.
    070         * @param standardDeviation  the standard deviation.
    071         */
    072        public MeanAndStandardDeviation(double mean, double standardDeviation) {
    073            this(new Double(mean), new Double(standardDeviation));
    074        }
    075
    076        /**
    077         * Creates a new mean and standard deviation record.
    078         *
    079         * @param mean  the mean (<code>null</code> permitted).
    080         * @param standardDeviation  the standard deviation (<code>null</code>
    081         *                           permitted.
    082         */
    083        public MeanAndStandardDeviation(Number mean, Number standardDeviation) {
    084            this.mean = mean;
    085            this.standardDeviation = standardDeviation;
    086        }
    087
    088        /**
    089         * Returns the mean.
    090         *
    091         * @return The mean.
    092         */
    093        public Number getMean() {
    094            return this.mean;
    095        }
    096
    097        /**
    098         * Returns the mean as a double primitive.  If the underlying mean is
    099         * <code>null</code>, this method will return <code>Double.NaN</code>.
    100         *
    101         * @return The mean.
    102         *
    103         * @see #getMean()
    104         *
    105         * @since 1.0.7
    106         */
    107        public double getMeanValue() {
    108            double result = Double.NaN;
    109            if (this.mean != null) {
    110                result = this.mean.doubleValue();
    111            }
    112            return result;
    113        }
    114
    115        /**
    116         * Returns the standard deviation.
    117         *
    118         * @return The standard deviation.
    119         */
    120        public Number getStandardDeviation() {
    121            return this.standardDeviation;
    122        }
    123
    124        /**
    125         * Returns the standard deviation as a double primitive.  If the underlying
    126         * standard deviation is <code>null</code>, this method will return
    127         * <code>Double.NaN</code>.
    128         *
    129         * @return The standard deviation.
    130         *
    131         * @since 1.0.7
    132         */
    133        public double getStandardDeviationValue() {
    134            double result = Double.NaN;
    135            if (this.standardDeviation != null) {
    136                result = this.standardDeviation.doubleValue();
    137            }
    138            return result;
    139        }
    140
    141        /**
    142         * Tests this instance for equality with an arbitrary object.
    143         *
    144         * @param obj  the object (<code>null</code> permitted).
    145         *
    146         * @return A boolean.
    147         */
    148        public boolean equals(Object obj) {
    149            if (obj == this) {
    150                return true;
    151            }
    152            if (!(obj instanceof MeanAndStandardDeviation)) {
    153                return false;
    154            }
    155            MeanAndStandardDeviation that = (MeanAndStandardDeviation) obj;
    156            if (!ObjectUtilities.equal(this.mean, that.mean)) {
    157                return false;
    158            }
    159            if (!ObjectUtilities.equal(
    160                this.standardDeviation, that.standardDeviation)
    161            ) {
    162                return false;
    163            }
    164            return true;
    165        }
    166
    167        /**
    168         * Returns a string representing this instance.
    169         *
    170         * @return A string.
    171         *
    172         * @since 1.0.7
    173         */
    174        public String toString() {
    175            return "[" + this.mean + ", " + this.standardDeviation + "]";
    176        }
    177
    178    }